Package org.eclipse.cdt.core.language.settings.providers

## Interface ILanguageSettingsProvider

All Known Subinterfaces:
  `ILanguageSettingsBroadcastingProvider`, `ILanguageSettingsEditableProvider`

All Known Implementing Classes:
  `LanguageSettingsBaseProvider`, `LanguageSettingsGenericProvider`, `LanguageSettingsSerializableProvider`

    public interface ILanguageSettingsProvider

Base interface to provide list of `ICLanguageSettingEntry`. This interface is used to deliver additions to compiler options such as include paths (-I) or preprocessor defines (-D) and others (see `ICSettingEntry.INCLUDE_PATH` and other kinds).
To define a provider like that use extension point `org.eclipse.cdt.core.LanguageSettingsProvider` and implement this interface. The recommended way of implementing is to extend `LanguageSettingsSerializableProvider` and implement `ILanguageSettingsEditableProvider`. That will give the ability to persist and edit/clean entries by user in UI. The clone methods defined by `ILanguageSettingsEditableProvider` should be chained as done for example by `LanguageSettingsGenericProvider`.
CDT provides a few general use implementations in the core such as `LanguageSettingsBaseProvider` or `LanguageSettingsSerializableProvider` or `LanguageSettingsGenericProvider` which could be used out of the box or built upon. There are also abstract classes in build plugins `AbstractBuildCommandParser` and `AbstractBuiltinSpecsDetector` which serve as a base for output parsers and built-in compiler language settings detectors. See also extension point schema description LanguageSettingsProvider.exsd.

Since:
  5.4

### Method Summary

All Methods Instance Methods Abstract Methods
`String` `getId()` Id is used to keep track of the providers internally.
`String` `getName()` Name is used to present the provider to the end user in UI.
`List<ICLanguageSettingEntry>` `getSettingEntries​(ICConfigurationDescription cfgDescription, org.eclipse.core.resources.IResource rc, String languageId)` Returns the list of setting entries for the given configuration description, resource and language.

### Method Detail

#### getId

    String getId()

Id is used to keep track of the providers internally. Use unique id to represent the provider.

Returns:
  Id of the provider.

#### getName

    String getName()

Name is used to present the provider to the end user in UI.

Returns:
  name of the provider.

#### getSettingEntries

    List<ICLanguageSettingEntry> getSettingEntries​(ICConfigurationDescription cfgDescription,
                                                   org.eclipse.core.resources.IResource rc,
                                                   String languageId)

Returns the list of setting entries for the given configuration description, resource and language.
Note to implementers - this method should not be used to do any long running operations such as extensive calculations or reading files. If you need to do so, the recommended way is to do the calculations outside of this function call - in advance and on appropriate event. For example, Build Output Parser prepares the list and stores it in internal cache while parsing output. `getSettingEntries(ICConfigurationDescription, IResource, String)` will return cached entries when asked. You can also implement `ICListenerAgent` interface to get registered and listen to arbitrary events.

Parameters:
  `cfgDescription` - - configuration description.
  `rc` - - resource such as file or folder. If `null`, the default entries for all resources are returned.
  `languageId` - - language id. If `null`, the default entries for all languages are returned. (see `LanguageManager.getLanguageForFile(org.eclipse.core.resources.IFile, ICConfigurationDescription)`).
Returns:
  the list of setting entries or `null` if no settings defined. The list needs to be a pooled list created by `LanguageSettingsStorage.getPooledList(List)` to save memory and avoid deep equality comparisons.